#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define f_get1(t)\
	t = (flag & 1);\
	flag >>= 1;\
	flag_count -= 1;\
	f_chk(0);

#define f_chk(w)\
	if(w >= flag_count){\
		flag |= ((src[ofs] | (src[ofs + 1] << 8)) << flag_count);\
		ofs += 2;\
		flag_count += 16;\
	}


static long expand(unsigned char *dest, unsigned char *src, long size){
	unsigned int flag;
	int flag_count;
	long ofs, dest_ofs;
	long t_len, t_ofs;
	int f;

	ofs = 0;
	dest_ofs = 0;
	flag = 0;
	flag_count = 0;

	f_chk(0);

	while(ofs < size){

		f_get1(f);
		if(0 != f){
			dest[dest_ofs] = src[ofs];
			dest_ofs += 1;
			ofs += 1;
			continue;
		}

		f_get1(f);
		if(0 == f){
			f_get1(f);
			t_len = f;
			f_get1(f);
			t_len = ((t_len << 1) | f);
			t_len = (t_len + 2);
			t_ofs = (0x100 - src[ofs]);
			ofs += 1;
		}
		else{
			t_ofs = src[ofs];
			t_len = src[ofs + 1];
			t_ofs = (t_ofs | ((t_len << 5) & 0x1f00));
			t_ofs = (0x2000 - t_ofs);
			t_len = ((t_len & 7) + 2);
			ofs += 2;
			if(2 == t_len){
				t_len = src[ofs];
				ofs += 1;
				if(0 == t_len){
					break;
				}
				if(1 == t_len){
					continue;
				}
				t_len += 1;
			}
		}

		t_ofs = (dest_ofs - t_ofs);
		while(0 < t_len){
			dest[dest_ofs] = dest[t_ofs];
			dest_ofs += 1;
			t_ofs += 1;
			t_len -= 1;
		}

	}

	return dest_ofs;
}


int main(int argc, char *argv[]){
	unsigned char *src;
	long size;
	unsigned char *dest;
	long dest_size;


	if(2 > argc){
		exit(0);
	}

	{
		FILE *f;
		f = fopen(argv[1], "rb");
		if(NULL == f){
			printf("t@C݂܂ (%s\n", argv[1]);
			exit(1);
		}
		fseek(f, 0, SEEK_END);
		size = ftell(f);
		src = malloc(size);
		if(NULL == src){
			fclose(f);
			printf("mۂł܂ł (%s\n", argv[1]);
			exit(1);
		}
		fseek(f, 0, SEEK_SET);
		fread(src, 1, size, f);
		fclose(f);
	}

	dest = malloc(0x10000);
	if(NULL == dest){
		free(src);
		printf("mۂł܂ł (%s\n", argv[1]);
		exit(1);
	}

	dest_size = expand(dest, src, size);

	{
		FILE *f;
		char *t;
		t = argv[1];
		if(3 <= argc){
			t = argv[2];
		}
		f = fopen(t, "wb");
		fwrite(dest, 1, dest_size, f);
		fclose(f);
	}

	free(dest);
	free(src);

	exit(0);
}
